#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <omp.h>
#include <assert.h>
#include <limits.h>
#include <string.h>
#include <time.h>

#include "random.c"

#include "insertion_sort_func.c"

void sort(int * arr, int len){
        insertion_sort(arr,len);
}

int main(int argc, char ** argv){

    if (argc<2){
            fprintf(stderr, "bucket_sort_openmp <thread_count>\n");
            exit(1);
    }
    
		clock_t start, end, total;
		
		
		
    
        int thread_count =strtol(argv[1],NULL,10);
    
        int * compl_arr;
        int i,j;
                int num_elmts;

        //input
        scanf("%d",&num_elmts);

        compl_arr = (int*) malloc(num_elmts*sizeof(int));

        //random elemen
        randomarr(compl_arr,num_elmts);

        for (i=0;i<num_elmts;i++){
            printf("%d ", compl_arr[i]);
        }
        printf("\n");
		start = clock();
        //bagi-bagi
        int * num_elmts_in_buckets;
        int * buckets_bin;
        int ** buckets;

        num_elmts_in_buckets = (int*) malloc(thread_count*sizeof(int));
        buckets = (int**) malloc(thread_count*sizeof(int*));
        buckets_bin = (int*) malloc(thread_count*sizeof(int));

        for (i=0;i<thread_count;i++) buckets_bin[i]=num_elmts*(i+1)/thread_count;

        for (i=0;i<thread_count;i++){ num_elmts_in_buckets[i]=0; buckets[i]=malloc(num_elmts*sizeof(int));}

        for (i=0;i<num_elmts;i++){
                for (j=0;j<thread_count;j++){
                        if (compl_arr[i]<=buckets_bin[j]){
                                buckets[j][num_elmts_in_buckets[j]]=compl_arr[i];
                                num_elmts_in_buckets[j]++;
                                break;
                        }
                }
        }
        
        //buat reduksinya
        int * bucket_offset = malloc(thread_count*sizeof(int));
        int curbuck_offset = 0;
        for (i=0;i<thread_count;i++){
            bucket_offset[i]=curbuck_offset;
            curbuck_offset+=num_elmts_in_buckets[i];
        }

#pragma omp parallel for num_threads(thread_count)
        for (i=0;i<thread_count;i++)
        {
            sort(buckets[i], num_elmts_in_buckets[i]);
            
            //copy
            memcpy(&compl_arr[bucket_offset[i]],buckets[i],num_elmts_in_buckets[i]*sizeof(int));
        }
		end = clock();
		total = end - start;
		
        for (i=0;i<num_elmts;i++){
            printf("%d ", compl_arr[i]);
        }
        printf("\n");
        printf("Total waktu %f",(double)total/CLOCKS_PER_SEC);
        free(bucket_offset);
        free(num_elmts_in_buckets);
        for (i=0;i<thread_count;i++)
                free(buckets[i]);
        free(buckets);
        free(buckets_bin);
        free(compl_arr);

}

